#ifndef CDECL_DECLGEN_H_
#define CDECL_DECLGEN_H_

struct gen_rng;

enum {
	GEN_NO_FUNCTION   = 0x01,
	GEN_NO_STORAGE    = 0x02,
	GEN_NO_VOID       = 0x04,
	GEN_ONLY_REGISTER = 0x08,
};

struct cdecl_declspec *gen_qualifiers(struct gen_rng *rng, _Bool pointer);
struct cdecl_declspec *gen_typespecs(struct gen_rng *rng, _Bool novoid);
struct cdecl_declspec *gen_randomize_specs(struct gen_rng *rng,
                                           struct cdecl_declspec *specs);
struct cdecl_declspec *gen_declspecs(struct gen_rng *rng, unsigned flags);
struct cdecl_declarator *gen_declarators(struct gen_rng *rng);

struct gen_rng *gen_alloc_rng(const char *seed);
void gen_free_rng(struct gen_rng *rng);

void gen_free_declspecs(struct cdecl_declspec *x);
void gen_free_declarators(struct cdecl_declarator *x);

#endif
