#!/bin/sh
#
# Copyright © 2012 Nick Bowler
#
# Check randomdecl's output to make sure it actually generates a variety
# of declarations.
#
# License WTFPL2: Do What The Fuck You Want To Public License, version 2.
# This is free software: you are free to do what the fuck you want to.
# There is NO WARRANTY, to the extent permitted by law.

randomdecl=test/randomdecl$EXEEXT
test -x $randomdecl || exit 77

proc() {
	sed -f "$srcdir/tests/randomdecl-sanity.sed" \
		|| { echo "result=fail"; return 1; }
}

printf '%s: randomized test using RANDOMSEED=%d\n' "$0" "$RANDOMSEED"

result=pass
eval_cmd=`exec 3>&1
	{ $randomdecl -E -s "$RANDOMSEED" 3>&-
		echo gen_status=$? >&3
	} | proc >&3`
eval "$eval_cmd"

eval_cmd=`sed -ne 's/^\(.*\)=yes #\(.*\)$/\
	test x"$\1" = x"yes" || { echo no \2; result=fail; }/p' \
	tests/randomdecl-sanity.sed`
eval "$eval_cmd"

if test x"$result" != x"pass"; then
	printf '%s: test failed\n' "$0"
	exit 1
fi
